<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once($path.$arr[0]['apache_path'].'inc/common_page.inc.php');

if(isset($_GET['day'])){
	$day = $_GET['day'];

	$since =  DateTime::createFromFormat('H:i:s j/m', "00:00:00 $day")->format('U');
	$until =  DateTime::createFromFormat('H:i:s j/m', "23:59:59 $day")->format('U');

	//Récupération des status)
	$bck_list=Model_Backup::getAllBackupByTypeSince($dbconnection, $srv_id,$_GET['action'],$since,$until);
	$esia_status_pri = array(2,1,3,0);

	//Calcul des différentes dates de la periode
	$dates=array();
	for($i=23;$i>=0;$i--){
		$dates[]= "$i h";
	}

	//Récupération de la liste des noeuds (job-name | job-source)
	$nodes = Model_Backup::getAllBackupsName($dbconnection, $srv_id,$_GET['action']);
	foreach($nodes as $node){
		foreach($dates as $date){
			$nodes_list[$node][$date] = 4;
		}
	}
	$periodformat='G \h';
	$specific_cl='small_case_hours';
}
else{
	//Récupération des status)
	$since = new DateTime();
	$since->sub(new DateInterval('P2W'));

	$bck_list=Model_Backup::getAllBackupByTypeSince($dbconnection, $srv_id,$_GET['action'],$since->format('U'));
	$esia_status_pri = array(2,1,3,0);

	//Calcul des différentes dates de la periode
	$dates=array();
	$current_date=new DateTime();
	do{
		$date_str = $current_date->format('d/m');
		$dates[]= $date_str;
		$current_date->sub(new DateInterval('P1D'));
	}while($current_date > $since);

	//Récupération de la liste des noeuds (job-name | job-source)
	$nodes = Model_Backup::getAllBackupsName($dbconnection, $srv_id,$_GET['action']);
	foreach($nodes as $node){
		foreach($dates as $date){
			$nodes_list[$node][$date] = 4;
		}
	}

	$periodformat='d/m';
	$specific_cl='';
}

//Attribution des status aux noeuds
$now_ts = time();
$nodes_stats = array();
$nodes_status = array();
foreach($bck_list as $bck){
	$dt = new DateTime($bck['date']);
	$hours = $dt->format($periodformat); //periodformat configuré dans le if/else

	if(!isset($nodes_list[$bck['name']][$hours])) continue;
	$actual_status = $nodes_list[$bck['name']][$hours];

	if( $actual_status == null || $actual_status == 4) $new_status = $bck['status'];
	else{
		foreach($esia_status_pri as $st){
			if( $actual_status == $st || $bck['status'] == $st ){
				$new_status = $st;
				break;
			}
		}
	}

	$text = $bck['date'];
	switch($bck['status']){
		case 0 : $text .= ' : '.$lang['LGD_OK']; break;
		case 1 : $text .= ' : '.$lang['LGD_WARN']; break;
		case 2 : $text .= ' : '.$lang['LGD_CRI']; break;
	}

	$text.="\n";

	if(!isset($nodes_stats[$bck['name']][$hours]['total'])){
		$nodes_stats[$bck['name']][$hours]['total']=0;
		$nodes_stats[$bck['name']][$hours][0]=0;
		$nodes_stats[$bck['name']][$hours][1]=0;
		$nodes_stats[$bck['name']][$hours][2]=0;
		$nodes_stats[$bck['name']][$hours][3]=0;

		$nodes_status[$bck['name']][$hours] = $text;
	}
	else {
		$nodes_status[$bck['name']][$hours] .= $text;
	}

	$nodes_stats[$bck['name']][$hours]['total']++;
	$nodes_stats[$bck['name']][$hours][$bck['status']]++;
	$nodes_list[$bck['name']][$hours] = $new_status;
}

	//Modifications de l'affichage des dates.
$bydate = array();
foreach($nodes_list as $name => $item){
	$row = array();
	$row['add']['checkbox'] = array(
			'name'	=> $name,
			'value'	=> $name
	);

	$row['name'] = $name;
	foreach($item as $key => $value){
		$row[$key] = $value;
	}
	$bydate[] = $row;
}

//Derniers ajustements avant affichage
$small_cases = array_keys($bydate[0]);
array_shift($small_cases); //Delete de la première colonne, (celle des add).
array_shift($small_cases); //Delete de la première colonne, (celle des noms).
array_walk($bydate,'arr_set_class',array(implode(',',$small_cases),'small_case'));

$tab['name'] = 'bck_by_date_'.$_GET['action'];
$tab['title'] = $lang['BCK_TITLE_LAST_BACKUPS'];
$tab['pager'] = true;
$tab['tablesorter'] = true;

if(isset($_GET['day']) && $_GET['day']){
	$tab['title'] .= " ".$_GET['day'];
}

foreach($bydate[0] as $key => $cell){
	if( $key !== 'name' && $key !== 'add'){
		$tab['header'][$key]['cl'] = "sorter-false filter-false columnSelector-disable small_case $specific_cl";

		if(empty($_GET['day'])){
			$host     = $_SERVER['HTTP_HOST'];
			$script   = $_SERVER['SCRIPT_NAME'];
			$params   = $_SERVER['QUERY_STRING'];
			$params	  .= '&day='.urlencode("$key");

			$tab['header'][$key]['lnk'] = htmlentities("$script?$params");
		}
	}
}

$job_sources_list = Model_Backup::getJobSourcesList($dbconnection, $srv_id);

$sourceToJob = array();
$jobsNames = array();
foreach($job_sources_list as $row){
	$sourceToJob[$row['job_source']] = $row['job_name'];
    $jobsNames[]=$row['job_name'];
}

$jobsNames = array_unique($jobsNames);

$data=array();
foreach($bydate as $row_num => $row){
	if( $_GET['action'] == 'source' ){
		$data[$row_num][$lang['ADD']] = $bydate[$row_num]['add'];
		$data[$row_num][$lang['NAME']] = $bydate[$row_num]['name'];
		$data[$row_num][$lang['BCK_JOB_NAME']] = $sourceToJob[$bydate[$row_num]['name']];
	}
	else{
		$data[$row_num][$lang['ADD']] = $bydate[$row_num]['add'];
		$data[$row_num][$lang['BCK_JOB_NAME']] = $bydate[$row_num]['name'];
	}

	foreach($small_cases as $key => $hours){
		if( $data[$row_num][$hours]['data'] == 4){
			$data[$row_num][$hours]['data'] = '';
		}
		else{
			$status = '';
			switch($bydate[$row_num][$hours]['data']){
				case 0 : $status='EventOK'; break;
				case 1 : $status='EventWarning'; break;
				case 2 : $status='EventCritical'; break;
			}
			$data[$row_num][$hours]['cl'] = $row[$hours]['cl']." $status";
		}

		if( isset($nodes_stats[$row['name']][$hours])){
			$text = $nodes_stats[$row['name']][$hours][0];
			$text.= '/'.$nodes_stats[$row['name']][$hours]['total'];
			$data[$row_num][$hours]['data'] = $text;
			$data[$row_num][$hours]['title'] = $nodes_status[$row['name']][$hours];
		}
	}
}

$tab['data'] = $data;

$smarty->assign('table',$tab);
$plugin_fields = array_shift(Model_esia::getPlugin($dbconnection,'CHECK_DB_BACKUPS'));
$parameters = $plugin_fields['parameter'];
$smarty->assign('admin_checks',array(
		'check' => 'CHECK_DB_BACKUPS',
		'common'=>$commonName,
		'default'=>$parameters
));

$parametersJob = $parameters . ' -J';
$parametersJob=str_replace('"<SRC_NAME>"','"<$JOB_NAME>"',$parametersJob);
$parametersJob=str_replace('<SRC_NAME>','"<$JOB_NAME>"',$parametersJob);

$smarty->assign('admin_simplify',array(
		'check' => 'CHECK_DB_BACKUPS',
		'common'=>$commonName,
		'default'=>$parametersJob
));
sort($jobsNames);
$smarty->assign('page_id','dg');
$smarty->assign('action',$_GET['action']);
$smarty->assign('admin_objects_list',$jobsNames);
$smarty->display($template_path.'bck_gantt_view.html');
?>
